/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.service.impl;

import org.springblade.common.utils.GenerateNum;
import org.springblade.core.tool.api.R;
import org.springblade.estate.entity.WorkOrder;
import org.springblade.estate.vo.WorkOrderVO;
import org.springblade.estate.mapper.WorkOrderMapper;
import org.springblade.estate.service.IWorkOrderService;
import org.springblade.core.mp.base.BaseServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.Date;

/**
 *  服务实现类
 *
 * @author BladeX
 * @since 2021-12-28
 */
@Service
public class WorkOrderServiceImpl extends BaseServiceImpl<WorkOrderMapper, WorkOrder> implements IWorkOrderService {

	@Override
	public IPage<WorkOrderVO> selectWorkOrderPage(IPage<WorkOrderVO> page, WorkOrderVO workOrder) {
		return page.setRecords(baseMapper.selectWorkOrderPage(page, workOrder));
	}

	@Override
	public R<WorkOrder> generateWorkOrder(String orderName, Integer eventType, String eventDesc, String bizTag, Long groupUserId,
										  String img, String contact, String contactPhone, Date handleTime, Long groupId) {
		WorkOrder workOrder = new WorkOrder();
		workOrder.setOrderNo("RE" + GenerateNum.generateNum());
		workOrder.setImg(img);
		workOrder.setBizTag(bizTag);
		workOrder.setContact(contact);
		workOrder.setContactPhone(contactPhone);
		workOrder.setGroupUserId(groupUserId);
		workOrder.setOrderName(orderName);
		workOrder.setEventType(eventType);
		workOrder.setEventDesc(eventDesc);
		workOrder.setHandleTime(handleTime);
		workOrder.setGroupId(groupId);
		boolean save = this.save(workOrder);
		if(save){
			return R.data(workOrder);
		}else{
			return R.status(false);
		}
	}

}
